#include "attribute.h"




CAttribute::CAttribute(int *p,bool bd )  
: i(p),m_bDynamic(bd),m_Type(AT_INT)
{
	assert(p);
}
CAttribute::CAttribute(float *p,bool bd ) 
: f(p),m_bDynamic(bd),m_Type(AT_FLOAT)
{
	assert(p);
}
CAttribute::CAttribute(double *p,bool bd ) 
: d(p),m_bDynamic(bd),m_Type(AT_DOUBLE)
{
	assert(p);
}
CAttribute::CAttribute(std::string *p,bool bd ) 
: s(p),m_bDynamic(bd),m_Type(AT_STRING)
{
	assert(p);
}


const std::string CAttribute::GetName() const 
{
	return m_Name;
}

bool CAttribute::IsDynamicAttr() const 
{
	return m_bDynamic;
}

int CAttribute::AsInt() 
{
	switch(m_Type) {
		case AT_INT:
			return static_cast<int>(*i);
			break;
		case AT_FLOAT:
			return static_cast<int>(*f);
			break;
		case AT_DOUBLE:
			return static_cast<int>(*d);
			break;
		default:
			break;
	}
	return 0;
}

float CAttribute::AsFloat()
{
	switch(m_Type) {
		case AT_INT:
			return static_cast<float>(*i);
			break;
		case AT_FLOAT:
			return static_cast<float>(*f);
			break;
		case AT_DOUBLE:
			return static_cast<float>(*d);
			break;
		default:
			break;
	}
	return 0;
}

double CAttribute::AsDouble() 
{
	switch(m_Type) {
		case AT_INT:
			return static_cast<double>(*i);
			break;
		case AT_FLOAT:
			return static_cast<double>(*f);
			break;
		case AT_DOUBLE:
			return static_cast<double>(*d);
			break;
		default:
			break;
	}
	return 0;
}

std::string CAttribute::AsString() 
{
	switch(m_Type) {
		case AT_STRING:
			return *s;
			break;
		default:
			break;
	}
	return NULL;
}


void CAttribute::Set(int v) 
{
	switch(m_Type) {
		case AT_INT:
			*i = static_cast<int>(v);
			break;
		case AT_FLOAT:
			*f = static_cast<float>(v);
			break;
		case AT_DOUBLE:
			*d = static_cast<double>(v);
			break;
		default:
			break;
	}
}

void CAttribute::Set(float v) 
{
	switch(m_Type) {
		case AT_INT:
			*i = static_cast<int>(v);
			break;
		case AT_FLOAT:
			*f = static_cast<float>(v);
			break;
		case AT_DOUBLE:
			*d = static_cast<double>(v);
			break;
		default:
			break;
	}
}

void CAttribute::Set(double v) 
{
	switch(m_Type) {
		case AT_INT:
			*i = static_cast<int>(v);
			break;
		case AT_FLOAT:
			*f = static_cast<float>(v);
			break;
		case AT_DOUBLE:
			*d = static_cast<double>(v);
			break;
		default:
			break;
	}
}
void CAttribute::Set(std::string v) 
{
	switch(m_Type) {
		case AT_STRING:
			*s = v;
			break;
		default:
			break;
	}
}
