#include "node.h"

CNode::CNode(void)
{
}

CNode::~CNode(void)
{
}
bool CNode::AddAttr(std::string type,std::string name)
{
	AttrIt it = m_Attributes.find(name);

	if (it != m_Attributes.end() ) {
		std::cerr << "Attribute already present on node : " << name << std::endl;
		return false;
	}

	if (type == "int")
		m_Attributes.insert( std::make_pair(name,CAttribute(new int,true)) );
	else
		if (type == "float")
			m_Attributes.insert( std::make_pair(name,CAttribute(new float,true)) );
		else
			if (type == "double")
				m_Attributes.insert( std::make_pair(name,CAttribute(new double,true)) );
			else
				if (type == "string")
					m_Attributes.insert( std::make_pair(name,CAttribute(new std::string,true)) );
				else
				{
					std::cerr << "Uknown type : " << type.c_str() << std::endl;
					return false;
				}

	return true;
}


Type CNode::GetAttrType(std::string attr)
{
	AttrIt it = m_Attributes.find(attr);

	if (it != m_Attributes.end() ) 
	{
		return it->second.GetType();
	}

	return AT_INT;	
}

bool CNode::DelAttr(std::string name)
{
	AttrIt it = m_Attributes.find(name);

	if (it != m_Attributes.end() ) 
	{
		if(it->second.IsDynamicAttr())
		{
			m_Attributes.erase(it);
			return true;
		}
	}
	return false;
}

void CNode::ListAttr() 
{
	AttrIt it = m_Attributes.begin();
	for( ; it != m_Attributes.end(); ++it ) {
		std::cerr << it->first << std::endl;
	}
}

bool CNode::GetAttr(std::string name, std::string &val)
{
	AttrIt it = m_Attributes.find(name);

	if (it != m_Attributes.end() ) 
	{
		val = it->second.AsString();
		return true;
	}
	return false;
}

bool CNode::GetAttr(std::string name, double &val)
{
	AttrIt it = m_Attributes.find(name);

	if (it != m_Attributes.end() ) 
	{
		val = it->second.AsDouble();
		return true;
	}
	return false;
}

bool CNode::SetAttr(std::string name, std::string val)
{
	AttrIt it = m_Attributes.find(name);

	if (it != m_Attributes.end() ) 
	{
		it->second.Set(val);
		return true;
	}
	return false;

}
bool CNode::SetAttr(std::string name, double val)
{
	AttrIt it = m_Attributes.find(name);

	if (it != m_Attributes.end() ) 
	{
		it->second.Set(val);
		return true;
	}
	return false;
}